#!/bin/sh
###
# Findpath - скрипт для нахождения пакета по известной части пути файла в пакете
###
# Copyright (C) 2016 Serg A. Kotlyarov <shadowsbrother@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

aptrepo=/usr/bin/apt-repo
cut=/bin/cut
find=/bin/find
grep=/bin/grep
mkdir=/bin/mkdir
printenv=/usr/bin/printenv
sed=/bin/sed
sort=/bin/sort
tr=/usr/bin/tr
wc=/bin/wc
wget=/usr/bin/wget

br=('task' 'classic' 'main' 'updates')

get_index () {
$wget -c -P $1 $2
}

home=`$printenv HOME`
ar=`$aptrepo`
index=contents_index
task_uri=/base.next/$index
base_uri=/base/$index
basedir=$home'/.'$index
[[ $basedir ]] || $mkdir $basedir
urls=`echo "$ar"|$sed "s,.*\(http:\|ftp:.*$\),\1,;/x86_32/d;/x86_64-i586/d"`
for z in ${br[@]}
do
 urls1=`echo "$urls"|$grep "$z$"`
 [[ -z $urls1 ]] && continue
 [[ $z == "task" ]] && urls3=$task_uri || urls3=$base_uri
 urls1=`echo "$urls1"|$sed "s, $z,$urls3,"`
 [[ $z == "task" ]] && urls4=$'\n' || urls4=
 urls2="$urls2$urls1$urls4"
done
urls2=`echo "$urls2"|$tr ' ' '/'`
urls3=`echo "$urls2"|$wc -l`
l=0
for ((m=1;m<=urls3;m++))
do
 surl=`echo "$urls2"|$sed "$m!d"`
 urlpath="$basedir/`echo "$surl"|$sed "s,/base/$index,,;s,/base.next/$index,,"|$tr '/' '_'`"
 [[ -s $urlpath/$index ]] && continue
 check_url[$l]=$surl
 check_path[$l]=$urlpath
 l=$[$l+1]
done
if [[ $l -gt 0 ]]; then
 echo "Имеются репозитории, для которых отсутствуют локальные копии индексных файлов."\
      $'\n'"Выполняется загрузка файлов:"\
      $'\n'
 for ((n=0;n<=l;n++))
 do get_index ${check_path[$n]} ${check_url[$n]}
 done
fi
echo "Внимание!"\
     $'\n'"Для поиска пакета по частично известному (либо полному) пути или"\
     $'\n'"только имени файла используются локальные копии файлов индекса."
if ! [[ $# == 0 ]]; then
 for o in $@
 do
  files=`$find $home/.$index -type f`
  echo
  for p in $files
  do
   r=`$grep "$o" $p|$cut -f2|$sort -u`
   [[ $r ]] && echo "Поиск по аргументу $o (`echo $p|$sed "s,^$basedir/,,"`):"$'\n'"$r"$'\n' || continue 
  done
 done
fi